/* global BdfApi */

/**
 * @constructor
 * @param {String} fichothequeUrl
 * @param {Object} options
  */
BdfApi.Config = function (fichothequeUrl, options) {
    this.fichothequeUrl = fichothequeUrl;
    this.options = {};
    if (options) {
        for(var key in options) {
            this.options[key] = options[key];
        }
    }
};

/**
 * 
 * @param {String} actionName
 * @returns {String}
 */
BdfApi.Config.prototype.getActionUrl = function (actionName) {
    return this.fichothequeUrl + actionName;
};

/**
 * 
 * @param {String} corpus Nom du corpus
 * @param {Number} id Identifiant de la fiche
 * @returns {String}
 */
BdfApi.Config.prototype.getFicheUrl = function (corpus, id, format) {
    var url = this.fichothequeUrl + "fiches/" + corpus + "-" + id;
    if (format) {
        url += "-" + format;
    }
    url = url + ".html";
    return url;
};
