/* global FicheQL */

FicheQL.Condition.Croisement = function (options) {
  this._lienModeArray = new Array();
  this._poidsRangeArray = new Array();
  this.poidsExcludeMode = false;
  if (options) {
        for(var key in options) {
            if (key.indexOf('_') !== 0) {
                var value = options[key];
                switch(key) {
                    case "lienModes":
                        this.addLienModes(value);
                        break;
                    case "poidsRanges":
                        this._poidsRangeArray = FicheQL.toRangeArray(value);
                        break;
                    default:
                        this[key] = value;
                }
            }
        }
    }
};

FicheQL.Condition.Croisement.prototype.addLienModes = function (lienModes) {
    var tmparray = lienModes.split(" ");
    for(var i = 0, len = tmparray.length; i < len; i++) {
        var modeVal = tmparray[i];
        if (modeVal.length > 0) {
            this._lienModeArray.push(modeVal);
        }
    }
    return this;
};

FicheQL.Condition.Croisement.prototype.addPoidsRange = function (start, end) {
    this._poidsRangeArray = FicheQL.addRange(this._poidsRangeArray, start, end);
    return this;
};

FicheQL.Condition.Croisement.prototype.toXml = function (indent) {
    var xml = '';
    var _indent = function() {
        if (indent >= 0) {
            xml += '\n';
            for(var i = 0; i < indent; i++) {
                xml += '\t';
            }
        }
    };
    for(var i = 0, len = this._lienModeArray.length; i < len; i ++) {
        _indent();
        xml += '<lien-mode>' + FicheQL.escape(this._lienModeArray[i]) + '</lien-mode>';
    }
    var poidsRangeLength = this._poidsRangeArray.length;
    if (poidsRangeLength > 0) {
        _indent();
        xml += '<lien-poids';
        if (this.poidsExcludeMode) {
            xml += " mode='exclude'";
        }
        xml += '>';
        for(var i = 0; i < poidsRangeLength; i++) {
            if (i > 0) {
                xml += ';';
            }
            xml += FicheQL.escape(this._poidsRangeArray[i]);
        }
        xml += '</lien-poids>';
    }
    return xml;
};
