/* global BDF,Overlay,Importation */

Importation.Overlay = {};

Importation.Overlay.showParseResult = function (parseResult) {
    var contentHtml  = "";
    var footerHtml, formAttrs;
    var withError = false;
    var withWarning = false;
    if (parseResult.initErrorArray) {
        withError = true;
        contentHtml += BDF.render("importation:initerrors", {
            array: parseResult.initErrorArray
        });
    }
    if (parseResult.initWarningArray) {
        withWarning = true;
        contentHtml += BDF.render("importation:initwarnings", {
            array: parseResult.initWarningArray
        });
    }
    if (parseResult.parseErrorArray) {
        withError = true;
        contentHtml += BDF.render("importation:parseerrors", {
            array: parseResult.parseErrorArray
        });
    }
    if (parseResult.bdfErrorArray) {
        withError = true;
        contentHtml += BDF.render("importation:bdferrors", {
            array: parseResult.bdfErrorArray
        });
    }
    if ((parseResult.tmpFile || parseResult.tmpDir)  && ((!withWarning) && (!withError))) {
        formAttrs = {
            action: BDF.URL + "importation",
            method: "POST"
        };
        contentHtml += BDF.render("importation:confirm", {
           type: parseResult.type,
           page: Importation.getPageFromType(parseResult.type),
           tmpFile: parseResult.tmpFile,
           tmpDir: parseResult.tmpDir,
           subsetHtml: _getSubsetHtml()
        });
        footerHtml = BDF.render("bdf:overlay-footer", {
            submit: {
                locKey: '_ submit.importation.confirm'
            }
        });
    }
    Overlay.start({
        header: BDF.Loc.escape("_ title.importation.confirm"),
        content: contentHtml,
        footer: footerHtml,
        formAttrs: formAttrs
    });
    
    
    function _getSubsetHtml() {
        var $select = BDF.$({_element: "select", subset: "selection"});
        var $option = $select.find("option").filter(":selected"); 
        if ($option.length === 0) {
            return "";
        }
        var optionText = $option.text();
        var idx = optionText.indexOf(']');
        var subsetKey, subsetTitle;
        if (idx !== -1) {
            subsetKey = optionText.substring(0, idx + 1);
            subsetTitle = optionText.substring(idx + 1);
        }
        return BDF.render("importation:subset", {
            text: BDF.Loc.get(_getLabelKey($select.attr("name"))),
            subsetKey: subsetKey,
            subsetTitle: subsetTitle
        });
    }
    
    function _getLabelKey(name) {
        switch(name) {
            case "corpus":
                return "_ label.importation.corpus";
            case "thesaurus":
                return "_ label.importation.thesaurus";
            default:
                return "";
        }
    }
    
};
