/* global BDF,Multi,Overlay,$,$$ */

Multi.PersonManager = {};

Multi.PersonManager.load = function () {
    var managerId = BDF.generateId();
    $$("layout_main").html(BDF.render("multi:personmanager", {
        managerId: managerId
    }));
    $$(managerId, "searchform").ajaxForm({
        dataType: "json",
        success: function (data, textStatus, jqXHR, $form) {
            if ((Multi.testAuthentification(data)) && (BDF.Ajax.checkError(data))) {
                $$(managerId, "body").addClass("multi-personmanager-Active");
                _loadPerson(data);
                _loadCommands(data);
            }
       }
    });
     
    function _loadPerson(data) {
        _completeData(data);
        $$(managerId, "person").html(BDF.render("multi:personmanager-person", {
            managerId: managerId,
            person: data
        }));
    }
     
    function _loadCommands(data) {
         $$(managerId, "person").html(BDF.render("multi:personmanager-person", {
            managerId: managerId,
            person: data
        }));
        $$(managerId, "changeformarea").html(BDF.render("multi:personmanager-changeform", {
            managerId: managerId,
            person: data
        }));
        $$(managerId, "changeform").ajaxForm({
            dataType: "json",
            beforeSubmit: function (arr, $form, options) {
                let selectElement = ID(managerId, "changeform", "type");
                if (selectElement.options[selectElement.selectedIndex].value === "none") {
                    return false;
                } else {
                    return true;
                }
            },
            success: function (data, textStatus, jqXHR, $form) {
                if ((Multi.testAuthentification(data)) && (BDF.Ajax.checkError(data))) {
                    _loadPerson(data);
                    if ((data.commandMessage) && (data.commandMessage.type === "done")) {
                        let $message = $$(managerId, "changeform", "donemessage");
                        $message.text(data.commandMessage.text).removeClass("hidden");
                        window.setTimeout(function () {
                            $message.addClass("hidden");
                        }, 5000);
                    }
                    $$(managerId, "body").scrollTop(0);
                }
           }
        });
        $$(managerId, "changeform", "type").change(function () {
            let type = this.options[this.selectedIndex].value;
            if (type === "none") {
                 $$(managerId, "changeform", "submit").addClass("hidden");
            } else {
                $$(managerId, "changeform", "submit").removeClass("hidden");
            }
            let $manager = $$(managerId, "changeform");
            BDF.$($manager, {role: "type"}).addClass("hidden");
            BDF.$($manager, {role: "type", type: type}).removeClass("hidden");
        });
        BDF.Deploy.init($$(managerId, "changeformarea"));        
     }
     
    function _completeData(data) {
        var withSpecificName = false;
        for(let status of data.statusArray) {
            status._levelLetter = _getLevelLetter(status.level);
            if (status.hasOwnProperty("specificName")) {
                withSpecificName = true;
            }
        }
        data._withSpecificName = withSpecificName;
    }
    
    function _getLevelLetter(level) {
        switch(level) {
            case "admin":
                return "A";
            case "user":
                return "U";
            case "inactive":
                return "I";
            default:
                return "X";
        }
    }
     
};

